"""
Django settings for prjannot project.

Generated by "django-admin startproject" using Django 1.7

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings
"""

# import from django
# bue 20150303: for delete_selectd action
from django.contrib import admin
# import from python
import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
#BASE_DIR = os.path.dirname(os.path.dirname(__file__))
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# bue 20141220: annot password key chain
from  prjannot import crowbar

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/


# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = crowbar.SECRET_KEY  #'!b&6os3taht2zpyib8&9-l%qah&1djdn%(0^0m4tbw+=cka6zn'

# SECURITY WARNING: don"t run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['webdev','web']


# Application definition
INSTALLED_APPS = (
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    # django selectable
    'selectable',
    ## ontologies ##
    "apponantibodypart_bioontology",
    "apponbiologicalprocess_go",
    "apponcelltype_bioontology",
    "apponcellularcomponent_go",
    "apponclonality_bioontology",
    "apponcompound_ebi",
    "appondisease_bioontology",
    "appondye_own",
    "apponethnicity_bioontology",
    "apponexperimentaldesigntype_bioontology",
    "appongene_ensembl",
    "appongeneontology_go",
    "appongeneticmodification_bioontology",
    "appongrowthproperty_bioontology",
    "apponhealthstatus_own",
    "apponimmunologyisotype_bioontology",
    "apponmolecularfunction_go",
    "apponorgan_bioontology",
    "apponorganism_bioontology",
    "apponprotein_uniprot",
    "apponprotocoltype_own",
    "apponprovider_own",
    "apponpublicationstatus_bioontology",
    "apponsample_cellosaurus",
    "apponsampleentity_own",
    "apponsex_bioontology",
    "appontissue_bioontology",
    "appontransientmodification_bioontology",
    "apponunit_bioontology",
    "apponverificationprofile_own",
    "apponyieldfraction_own",
    ## bricks, bridges and pipelines ##
    "appbrofperson",
    "appbrofprotocol",
    "appbrofpublication",
    "appbrreagentantibody",
    "appbrreagentcompound",
    "appbrreagentprotein",
    "appbrsamplehuman",
    "appbeendpoint",
    "appbeperturbation",
    "appbesample",
    "app_study",
    "app_investigation",
    # assay ##
    "appas_mema2",
    "appas_well1",
    ## sys admin ##
    "appsavocabulary",
    "appsabrick",
    "appsaarch",
    ## tools ##
    "apptourl",
    #"apptoomero",
    "apptodcic"
)

MIDDLEWARE_CLASSES = (
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    #"django.contrib.auth.middleware.SessionAuthenticationMiddleware",  # bue 20170417: not part of django 1.11
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
)

ROOT_URLCONF = "prjannot.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": ["/usr/src/app/prjannot/templates/"],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ],
        },
    },
]


WSGI_APPLICATION = "prjannot.wsgi.application"


# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases
DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.postgresql_psycopg2",
        "NAME": "annot",
        "USER": "annot",
        "PASSWORD": crowbar.PASSWD_DATABASE,
        "HOST": "db",  # os.environ['DB_SERVICE'] # 127.0.0.1
        "PORT": "5432",  # os.environ['DB_PORT']
    }
}


# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators
AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/
LANGUAGE_CODE = "en-us"
TIME_ZONE = "UTC" #"America/Los_Angeles", None
USE_I18N = True
USE_L10N = True
USE_TZ = False # True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/
# bue 20140911: updated to serve django admin static files
# bue 20151123: updated to serve prjannot admin static files
STATIC_ROOT = "/usr/src/static/"
STATIC_URL = "/static/"

# debian: "/usr/local/lib/python3.4/dist-packages/django/contrib/admin/static/admin/"
# freebsd: "/usr/local/lib/python3.4/site-packages/django/contrib/admin/static/admin"
STATICFILES_DIRS = (
    "/usr/local/lib/python3.6/site-packages/django/contrib/admin/static/admin",
    "/usr/src/app/prjannot/static/",
)


# bue 20140920 : add media path
MEDIA_ROOT = "/usr/src/media/"
MEDIA_ROOTQUARANTINE ="/usr/src/media/quarantine/"
MEDIA_ROOTURL ="/usr/src/media/url/"
MEDIA_URL = crowbar.URL + "media/"

# bue 20150303: delete_selectd action:
admin.site.disable_action('delete_selected')
